#include <systemc.h>

#include "top.h"

int sc_main( int argc, char* argv[] )
{
    sc_clock       clk( "clk", 10.0, SC_NS );
    TOP           *uTOP;
    sc_trace_file *trace_f;

    // TOP
    uTOP = new TOP( "uTOP" );
    uTOP->clk( clk );

    trace_f = sc_create_vcd_trace_file( "dump" );
    sc_trace( trace_f, uTOP->clk, "clk" );
    sc_trace( trace_f, uTOP->reset_n, "reset_n" );
    sc_trace( trace_f, uTOP->in_en, "in_en" );
    sc_trace( trace_f, uTOP->in_A, "in_A" );
    sc_trace( trace_f, uTOP->in_B, "in_B" );
    sc_trace( trace_f, uTOP->out_P, "out_P" );
    sc_trace( trace_f, uTOP->out_en, "out_en" );

    // simulation start
    sc_start();

    sc_close_vcd_trace_file( trace_f );
    delete uTOP;
    return 0;
}
